#include <stdio.h>
#include <string.h>
#include "personLibWDob.h"

// Print person object on screen
void print_person(struct Person person){
    printf("%s %s (%c) *%d.%d.%d",
        person.name, person.surname, person.sex, person.dob.day, person.dob.mon, person.dob.year
    );
}

//Reads person object from user. Returns 1 if the reading was success, 0 otherwise.
int scan_person(struct Person *person){
    printf("Enter new person (name surname sex day.month.year): ");
    int noOfScItems = scanf("%s %s %c %d.%d.%d", person->name, person->surname, &person->sex, &person->dob.day, &person->dob.mon, &person->dob.year);
    if(noOfScItems==6) return 1; else return 0;
}




/*
These functions return the value
0   if p1 and p2 are equal
<0  if p1 and p2 are in the correct order
>0  if p1 and p2 are not in the correct order

This is a three-way comparison function, https://en.wikipedia.org/wiki/Three-way_comparison
*/

int cmp_by_surname(const void* p1, const void* p2){
    const struct Person *person1 = (struct Person*)p1;
    const struct Person* person2 = (struct Person*)p2;


//    printf("\ncmp_by_surname:\n p1= ");
//    print_person(*person1);
//    printf("\n p2= ");
//    print_person(*person2);
//    printf("\n result: %d\n",strcmp(person1->surname, person2->surname));
//

    return strcmp(person1->surname, person2->surname);
}




