#include <stdio.h>
#include "fileUtils.h"

long file_size(char filename[]){
    FILE *fd = fopen(filename, "rb");
    if(fd == NULL){
        fprintf(stderr, "\nError opening the file %s\n",filename); //error messages should go to the stderr output stream
        return -1;
    }
    fseek(fd, 0L, SEEK_END);
    long sz=ftell(fd);
    fclose(fd);
    return sz;
}
